; ==============================================================================
; The fid/vid code itself (used in two places)
; Copyright 2004 Emboss, all rights reserved
; See licence.txt for details.
; ==============================================================================

  mov     ecx, 0C0010042h
  rdmsr
%ifdef FID_STARTUP
  shl     eax,8         ;   eax = ___:MFID ___:SFID ___:CFID 00000000
  mov     ax,0x13       ;   eax = ___:MFID ___:SFID 00000000 00010011
  rol     eax,16        ;   eax = 00000000 00010011 ___:MFID ___:SFID
  and     ax,0x1F       ;   eax = 00000000 00010011 00000000 000:SFID
%elifdef FID_MAX
  mov     ax,0x13       ;   eax = ________ ___:MFID 00000000 00010011
  rol     eax,16        ;   eax = 00000000 00010011 ________ ___:MFID
  and     ax,0x1F       ;   eax = 00000000 00010011 00000000 000:MFID
%elifdef FID_SET
  %ifdef VID_SET
    mov     eax,0x130000 + FID_CODE + VID_CODE*256
    xor     edx,edx    
  %else
    mov     eax,0x130000 + FID_CODE
  %endif
%endif

%ifdef VID_STARTUP
  and     dh,0x1F       ;   edx = ________ ___:MVID 000:SVID ___:CVID
  mov     ah,dh         ;   eax = 00000000 00010011 000:SVID 000:FID:
  xor     edx,edx       ;   edx = 00000000 00000000 00000000 00000000
%elifdef VID_MAX
  shr     edx,8         ;   edx = 00000000 ________ ___:MVID ___:SVID
  and     dh,0x1F       ;   edx = 00000000 ________ 000:MVID ___:SVID
  mov     ah,dh         ;   eax = 00000000 00010011 000:MVID 000:FID:
  xor     edx,edx       ;   edx = 00000000 00000000 00000000 00000000
%elifdef VID_SET
  %ifndef FID_SET
    mov     ah,VID_CODE
    xor     edx,edx
  %endif
%endif

  mov   dx,0x2710
  dec   cl
  wrmsr
  retn
