; ==============================================================================
; A patch to stop the SMP-disabling from happening on mobile CPUs. In this case
; it's easier to fix the symptoms (the setting of the "SMP-disable" bit than it
; is to fix the problem (the SMP-disabling-on-mobile code).
;
; Original code:
;   or      byte ptr es:[di+5], 2
;
; Bit 1 (0-based) of [es:di+5] controls whether SMP can happen or not. If it's
;   not set, then SMP will function.
; ==============================================================================

org 0x80A7

  nop
  nop
  nop
  nop
  nop

