; ==============================================================================
; A patch to stop the SMP-disabling from happening on mobile CPUs. The function
; at 0x859B sets the "SMP disable" bit if a mobile is detected. Changing this
; function to an empty function stops this from happening.
;
; Original code:
;   push    ax
;   mov     eax, 80000007h
;   cpuid
; ==============================================================================

org 0x859B

  ret

