; ==============================================================================
; The patch that intercepts the normal BIOS. It's called just before the BIOS
; code in 5000:0000-6000:FFFF gets moved to E000:0000-F000:FFFF.
;
; Gets patched into 2000:D760
; Can be anywhere downstream of E75D
; ==============================================================================
  org 0xD760

  db  0x81, 0xF9, 0x6F, 0x02, 0x00, 0x00, 0x76, 0xF3, 0x1E

  call  0x4E00:0                                  ; Replaces
                                                  ; D769  mov   si, ds
                                                  ; D76B  mov   di, 0E000h

  db 0xB9, 0x00, 0x80, 0xE8, 0x13, 0x20, 0x1F, 0x8C, 0xDE, 0x81, 0xC6, 0x00,
  db 0x10, 0xBF, 0x00, 0xF0, 0xB9, 0x00

